package eu.jonahbauer.tichu.common.model.combinations;

import eu.jonahbauer.tichu.common.model.Card;
import eu.jonahbauer.tichu.common.model.CombinationType;
import eu.jonahbauer.tichu.common.model.Stack;
import org.jetbrains.annotations.NotNull;

public sealed interface Bomb extends Combination permits BombTuple, BombSequence{
    @Override
    default boolean isCompatibleWith(@NotNull Stack stack) {
        return stack.isEmpty()
               || stack.top().type() != CombinationType.SINGLE
               || stack.top().card(0) != Card.HOUND;
    }
}
