package eu.jonahbauer.tichu.common.model.combinations;

import eu.jonahbauer.tichu.common.model.Card;
import eu.jonahbauer.tichu.common.model.CombinationType;
import org.jetbrains.annotations.NotNull;

import java.util.List;

/**
 * A combination of type {@link CombinationType#PAIR_SEQUENCE}
 */
public final class PairSequence extends Sequence {
    public static PairSequence of(@NotNull List<@NotNull Card> cards) {
        return new PairSequence(cards);
    }

    public static PairSequence of(@NotNull Card @NotNull... cards) {
        return new PairSequence(List.of(cards));
    }

    PairSequence(@NotNull List<@NotNull Card> cards) {
        super(CombinationType.PAIR_SEQUENCE, cards, 2);
    }
}
