package eu.jonahbauer.tichu.common.model.combinations;

import eu.jonahbauer.tichu.common.model.Card;
import eu.jonahbauer.tichu.common.model.CombinationType;
import org.jetbrains.annotations.NotNull;

import java.util.List;

/**
 * A combination of type {@link CombinationType#SEQUENCE}
 */
public final class SingleSequence extends Sequence {
    public static SingleSequence of(@NotNull List<@NotNull Card> cards) {
        return new SingleSequence(cards);
    }

    public static SingleSequence of(@NotNull Card @NotNull... cards) {
        return new SingleSequence(List.of(cards));
    }

    SingleSequence(@NotNull List<@NotNull Card> cards) {
        super(CombinationType.SEQUENCE, cards, 1);
    }
}
