package eu.jonahbauer.tichu.common.model.combinations;

import eu.jonahbauer.tichu.common.model.Card;
import eu.jonahbauer.tichu.common.model.CombinationType;
import org.jetbrains.annotations.Contract;
import org.jetbrains.annotations.NotNull;

import java.util.List;
import java.util.Objects;

/**
 * A combination of type {@link CombinationType#TRIPLE}
 */
public final class Triple extends Tuple {
    @Contract("_ -> new")
    public static @NotNull Triple of(@NotNull List<@NotNull Card> cards) {
        return new Triple(cards);
    }

    @Contract("_, _, _ -> new")
    public static @NotNull Triple of(@NotNull Card card1, @NotNull Card card2, @NotNull Card card3) {
        return new Triple(List.of(
                Objects.requireNonNull(card1, "card1 must not be null"),
                Objects.requireNonNull(card2, "card2 must not be null"),
                Objects.requireNonNull(card3, "card3 must not be null")
        ));
    }

    Triple(@NotNull List<@NotNull Card> cards) {
        super(CombinationType.TRIPLE, cards);
    }
}
