package eu.jonahbauer.tichu.common.model.exceptions;

import eu.jonahbauer.tichu.common.model.Card;
import eu.jonahbauer.tichu.common.model.CombinationType;
import lombok.Getter;
import org.jetbrains.annotations.NotNull;

import java.util.List;
import java.util.Objects;

@Getter
public class InvalidCombinationException extends IllegalArgumentException {
    private final @NotNull CombinationType type;
    private final @NotNull List<@NotNull Card> cards;

    public InvalidCombinationException(@NotNull CombinationType type, @NotNull List<@NotNull Card> cards) {
        this.type = Objects.requireNonNull(type, "type must not be null");
        this.cards = List.copyOf(Objects.requireNonNull(cards, "cards must not be null")); // List#copyOf performs null-checks
    }

    @Override
    public String getMessage() {
        return "%s does not compose a valid %s".formatted(cards, type);
    }
}
