package eu.jonahbauer.tichu.common.model;

import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.EnumSource;

import java.util.Set;

import static org.junit.jupiter.api.Assertions.assertFalse;
import static org.junit.jupiter.api.Assertions.assertTrue;

public class CardTest {

    @ParameterizedTest
    @EnumSource(Card.class)
    public void testGetNormalCardsContainsAllNormalCards(Card card) {
        Set<Card> normalCards = Card.getNormalCards();

        if (card.isNormal()) {
            assertTrue(
                    normalCards.contains(card),
                    "getNormalCards() should contain normal card %s".formatted(card)
            );
        } else {
            assertFalse(
                    normalCards.contains(card),
                    "getNormalCards() should not contain non-normal card %s".formatted(card)
            );
        }
    }

    @ParameterizedTest
    @EnumSource(Card.class)
    public void testGetSpecialCardsContainsAllSpecialCards(Card card) {
        Set<Card> specialCards = Card.getSpecialCards();
        if (card.isSpecial()) {
            assertTrue(
                    specialCards.contains(card),
                    "getSpecialCards() should contain special card %s".formatted(card)
            );
        } else {
            assertFalse(
                    specialCards.contains(card),
                    "getSpecialCards() should not contain non-special card %s".formatted(card)
            );
        }
    }

    @ParameterizedTest
    @EnumSource(Card.class)
    public void testIsNormalXorIsSpecial(Card card) {
        assertTrue(
                card.isNormal() ^ card.isSpecial(),
                "Card %s should be normal xor special".formatted(card)
        );
    }
}
